#ifndef DEFS_H_INCLUDED
#define DEFS_H_INCLUDED

//=============================================================================
// Constantes para la comunicacion con el software. (usadas en Type_Class HID)
#define USB_HID_CUSTOM_RQ___BUFFER_PRIMARIO     1
#define USB_HID_CUSTOM_RQ___BUFFER_DEUNAVEZ     2
#define USB_HID_CUSTOM_RQ___BUFFER_EEPROM       3
#define USB_HID_CUSTOM_RQ___INFO                4
#define USB_HID_CUSTOM_RQ___MODES               5
#define USB_HID_CUSTOM_RQ___LEDS_STATUS         6

//=============================================================================
// Constantes para la comunicacion con el software. (usadas en Type_Vendor)
#define RQ_CUSTOM___ECHO 1
#define RQ_CUSTOM___SET_LEDS_STATUS 2
#define RQ_CUSTOM___GET_LEDS_STATUS 3

#ifdef __FIRMWARE__

    //=============================================================================
    // USB, pines y mascaras
    #define USB_MASK ( BIT(USB_CFG_DPLUS_BIT) | BIT(USB_CFG_DMINUS_BIT) )


    //=============================================================================
    // LEDs
    #define LED_PORT_DDR   DDRC
    #define LED_PORT_WRITE PORTC
    #define LED_PORT_READ  PINC

    //=============================================================================
    // MACROS genericos
    #define IO_CONCAT(a, b)  a ## b
    #define IO_INPORT(name)  IO_CONCAT(PIN, name)
    #define IO_OUTPORT(name) IO_CONCAT(PORT, name)
    #define IO_DDRPORT(name) IO_CONCAT(DDR, name)
    #define BIT(x) (1 << (x))  // BIT position
    #define SBI(p,b) (p) |= BIT(b)
    #define CBI(p,b) (p) &= ~BIT(b)
    #define IS_SET(p,b) p & BIT(b)
    #define IS_NOT_SET(p,b) ~p & BIT(b)
    #define XOR(a,b) a^b
    #ifndef NULL
     #define NULL    ((void *)0)
    #endif
    #define NOP() asm volatile("nop\n\t"::)

#endif //__FIRMWARE__


#endif // DEFS_H_INCLUDED
